<?php
/*
  $Id: view_counter_update.php by Jack_mcs

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce
  Portions Copyright 2009 oscommerce-solution.com

  Released under the GNU General Public License
*/

/**************************************************************************
 This file will update existing installations of View Counter. To use it, 
 upload to your shops root directory and visit this page:
 http://YOUR DOMAIN NAME/view_counter_update.php
 *************************************************************************/
  require('includes/application_top.php');

  $db_error = false;
 
  $db_check_query = tep_db_query("select configuration_group_id as id from configuration_group where configuration_group_title = 'View Counter'");

  if (tep_db_num_rows($db_check_query) == 0) {
      $db_check_query = tep_db_query("select max(configuration_group_id) as id from configuration_group ");
      $max = tep_db_fetch_array($fb_check_query);
      $configuration_group_id = $max['id'] + 1;
 
      // create configuration group
      $group_query = "INSERT INTO configuration_group (configuration_group_id, configuration_group_title, configuration_group_description, sort_order, visible ) VALUES ('" . $configuration_group_id . "', 'View Counter', 'View Counter site wide options', '22' , '1')";
      if (tep_db_query($group_query) == false) {
        $db_error = true;
      }
  } else {
      $id = tep_db_fetch_array($db_check_query);
      $configuration_group_id = $id['id'];
  }

  if (! $db_error) {
    $options = array();
    $sortID = 1;
 
   /*********************** ADD ANY MISSING CONFIGURATION OPTIONS *************************/
    $db_check_query = tep_db_query("select * from configuration where configuration_group_id = " . (int)$configuration_group_id);
    while ($db_check = tep_db_fetch_array($db_check_query)) {
       if (! in_array($db_check['configuration_key'], $options)) { //skip duplicates
           $options[] = $db_check['configuration_key'];  //save all of the settings 
       }
    }
 
    // create configuration variables
    $fields = " configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added, use_function ";
    $fields_short = " configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added ";
    $db_sql_array = array();
    
    if (! in_array('VIEW_COUNTER_ENABLED', $options)) $db_sql_array[] = array("INSERT INTO configuration (" . $fields . ")  VALUES ('ON/OFF', 'VIEW_COUNTER_ENABLED', 'false', 'View Counter <br>(true=on false=off)', '" . $configuration_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now(), NULL)"); else $db_sql_array[] = GetCurrentSetting($fields, 'VIEW_COUNTER_ENABLED', $sortID++);
    if (! in_array('VIEW_COUNTER_API_KEY', $options)) $db_sql_array[] = array("INSERT INTO configuration (" . $fields_short . ") VALUES ('API Key','VIEW_COUNTER_API_KEY', 'Your API KEY', 'Enter your IPInfoDB.com API Key here.<br><br>You can get your key at http://ipinfodb.com/register.php', '" . $configuration_group_id . "', '" . ($sortID++). "', now())"); else $db_sql_array[] = GetCurrentSetting($fields_short, 'VIEW_COUNTER_API_KEY', $sortID++);
    if (! in_array('VIEW_COUNTER_ACTIVE_TIME', $options)) $db_sql_array[] = array("INSERT INTO configuration (" . $fields_short . ")  VALUES ('Active Time','VIEW_COUNTER_ACTIVE_TIME', '10', 'The number of minutes to show active visitors.', '" . $configuration_group_id . "', '" . ($sortID++). "', now())"); else $db_sql_array[] = GetCurrentSetting($fields_short, 'VIEW_COUNTER_ACTIVE_TIME', $sortID++);
    if (! in_array('VIEW_COUNTER_BAD_BOT_TRAP', $options)) $db_sql_array[] = array("INSERT INTO configuration (" . $fields . ")  VALUES ('Bad Bot Trap', 'VIEW_COUNTER_BAD_BOT_TRAP', 'Email', 'Choose how to handle the bad bot trap.<br><br><b>Ban:</b> Ban the IP<br><b>Email:</b> Send an Email containing the IP<br><b>Both:</b> Both of the above<br><b>Off:</b> Nothing will be done', '" . $configuration_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'Ban\', \'Email\', \'Both\', \'Off\'), ', now(), NULL)"); else $db_sql_array[] = GetCurrentSetting($fields, 'VIEW_COUNTER_BAD_BOT_TRAP', $sortID++);
    if (! in_array('VIEW_COUNTER_BLOCK_COUNTRIES', $options)) $db_sql_array[] = array("INSERT INTO configuration (" . $fields . ")  VALUES ('Block Countries', 'VIEW_COUNTER_BLOCK_COUNTRIES', 'false', 'Enable the country blocking code.', '" . $configuration_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now(), NULL)"); else $db_sql_array[] = GetCurrentSetting($fields, 'VIEW_COUNTER_BLOCK_COUNTRIES', $sortID++);
    if (! in_array('VIEW_COUNTER_DATE_FORMAT', $options)) $db_sql_array[] = array("INSERT INTO configuration (" . $fields_short . ")  VALUES ('Date Format','VIEW_COUNTER_DATE_FORMAT', '%a, %D %T', 'The format of the displayed date and time. This requires a valid string so only change it if you are familiar with the format.<br><br><b>12 hr:</b> %a, %D %r => Sun, 14th 01:39:56 PM<br><b>24 hr:</b> %a, %D %T => Sun, 14th 13:39:56<br><br>', '" . $configuration_group_id . "', '" . ($sortID++). "', now())"); else $db_sql_array[] = GetCurrentSetting($fields_short, 'VIEW_COUNTER_DATE_FORMAT', $sortID++);
    if (! in_array('VIEW_COUNTER_FORCE_RESET', $options)) $db_sql_array[] = array("INSERT INTO configuration (" . $fields_short . ")  VALUES ('Force Reset','VIEW_COUNTER_FORCE_RESET', '2', 'The maximum number of days to keep the IP\'s in the database. The View counter table will grow very large if not cleared and data over a few days is probably of no use.', '" . $configuration_group_id . "', '" . ($sortID++). "', now())"); else $db_sql_array[] = GetCurrentSetting($fields_short, 'VIEW_COUNTER_FORCE_RESET', $sortID++);
    if (! in_array('VIEW_COUNTER_FORCE_RESET_STORAGE', $options)) $db_sql_array[] = array("INSERT INTO configuration (" . $fields_short . ")  VALUES ('Force Reset Storage','VIEW_COUNTER_FORCE_RESET_STORAGE', '14', 'The maximum number of days to keep the IP\'s in the storage table. This table is used for reports. It will grow very large if not cleared on a regular basis.', '" . $configuration_group_id . "', '" . ($sortID++). "', now())"); else $db_sql_array[] = GetCurrentSetting($fields_short, 'VIEW_COUNTER_FORCE_RESET_STORAGE', $sortID++);
    if (! in_array('VIEW_COUNTER_HIDE_ADMIN_LINKS', $options)) $db_sql_array[] = array("INSERT INTO configuration (" . $fields_short . ")  VALUES ('Hide Admin Links','VIEW_COUNTER_HIDE_ADMIN_LINKS', '', 'Do not show admin links for these IP\'s. Use a comma separted list for multiple IP\'s.', '" . $configuration_group_id . "', '" . ($sortID++). "', now())"); else $db_sql_array[] = GetCurrentSetting($fields_short, 'VIEW_COUNTER_HIDE_ADMIN_LINKS', $sortID++);
    if (! in_array('VIEW_COUNTER_ITEM_NAME_LENGTH', $options)) $db_sql_array[] = array("INSERT INTO configuration (" . $fields_short . ")  VALUES ('Item Name Length','VIEW_COUNTER_ITEM_NAME_LENGTH', '20', 'The length of the names of the categories, manufacturers and products used in the monitor and report sections.', '" . $configuration_group_id . "', '" . ($sortID++). "', now())"); else $db_sql_array[] = GetCurrentSetting($fields_short, 'VIEW_COUNTER_ITEM_NAME_LENGTH', $sortID++);
    if (! in_array('VIEW_COUNTER_ENABLE_KILL_SESSION', $options)) $db_sql_array[] = array("INSERT INTO configuration (" . $fields . ")  VALUES ('Kick Off', 'VIEW_COUNTER_ENABLE_KILL_SESSION', 'false', 'Enable the ability to kick off customers.', '" . $configuration_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now(), NULL)"); else $db_sql_array[] = GetCurrentSetting($fields, 'VIEW_COUNTER_ENABLE_KILL_SESSION', $sortID++);
    if (! in_array('VIEW_COUNTER_PAGE_REFRESH', $options)) $db_sql_array[] = array("INSERT INTO configuration (" . $fields_short . ")  VALUES ('Page Refresh Period','VIEW_COUNTER_PAGE_REFRESH', '120', 'How often, in seconds, to refresh the main page in admin.', '" . $configuration_group_id . "', '" . ($sortID++). "', now())"); else $db_sql_array[] = GetCurrentSetting($fields_short, 'VIEW_COUNTER_PAGE_REFRESH', $sortID++);
    if (! in_array('VIEW_COUNTER_MAX_ROWS', $options)) $db_sql_array[] = array("INSERT INTO configuration (" . $fields_short . ")  VALUES ('Rows Per Page','VIEW_COUNTER_MAX_ROWS', '20', 'The maximum number of rows to display in the list.', '" . $configuration_group_id . "', '" . ($sortID++). "', now())"); else $db_sql_array[] = GetCurrentSetting($fields_short, 'VIEW_COUNTER_MAX_ROWS', $sortID++);
    if (! in_array('VIEW_COUNTER_SEND_EMAILS_TO', $options)) $db_sql_array[] = array("INSERT INTO configuration (" . $fields_short . ")  VALUES ('Send Emails To','VIEW_COUNTER_SEND_EMAILS_TO', '', 'The email address any emails created by View Counter will be sent to. If left empty, the shops email address will be used.', '" . $configuration_group_id . "', '" . ($sortID++). "', now())"); else $db_sql_array[] = GetCurrentSetting($fields_short, 'VIEW_COUNTER_SEND_EMAILS_TO', $sortID++);
    if (! in_array('VIEW_COUNTER_SHOW_FLAGS', $options)) $db_sql_array[] = array("INSERT INTO configuration (" . $fields . ")  VALUES ('Show Flags', 'VIEW_COUNTER_SHOW_FLAGS', 'true', 'Display the country flags. Turning this off will speed up the display. <br>(true=on false=off)', '" . $configuration_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now(), NULL)"); else $db_sql_array[] = GetCurrentSetting($fields, 'VIEW_COUNTER_SHOW_FLAGS', $sortID++);
    if (! in_array('VIEW_COUNTER_SHOW_ACCOUNT_DETAILS', $options)) $db_sql_array[] = array("INSERT INTO configuration (" . $fields . ")  VALUES ('Show Account Details', 'VIEW_COUNTER_SHOW_ACCOUNT_DETAILS', 'true', 'Display the account details of the visitor, if possible. If multiple accounts exist, they will all be shown. Enabling this option may cause a slow-down, depending upon the site. <br>(true=on false=off)', '" . $configuration_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now(), NULL)"); else $db_sql_array[] = GetCurrentSetting($fields, 'VIEW_COUNTER_SHOW_ACCOUNT_DETAILS', $sortID++);
    if (! in_array('VIEW_COUNTER_ENABLE_VERSION_CHECKER', $options)) $db_sql_array[] = array("INSERT INTO configuration (" . $fields . ")  VALUES ('Version Checker', 'VIEW_COUNTER_ENABLE_VERSION_CHECKER', 'false', 'Enable to automatically check if a new version is available. <br>(true=on false=off)', '" . $configuration_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now(), NULL)"); else $db_sql_array[] = GetCurrentSetting($fields, 'VIEW_COUNTER_ENABLE_VERSION_CHECKER', $sortID++);
    
    if (isset($options[1])) { //at least one setting exists
        $delete_query = "DELETE FROM configuration where configuration_group_id = " . (int)$configuration_group_id ;
        tep_db_query($delete_query);
    }    
 
    foreach ($db_sql_array as $sql_array) {
        foreach ($sql_array as $value) {
         //   echo 'update '.$value . '<br>';
            if (tep_db_query($value) == false) {
                $db_error = true;
            }
        }
    }
  }

?>
<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN">
<html <?php echo HTML_PARAMS; ?>>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo CHARSET; ?>">
<title><?php echo TITLE; ?></title>
<base href="<?php echo (($request_type == 'SSL') ? HTTPS_SERVER : HTTP_SERVER) . DIR_WS_CATALOG; ?>"> 
</head>
<body>


<!-- body //-->
<table border="0" width="100%" cellspacing="3" cellpadding="3">
  <tr>

<!-- body_text //-->
    <td width="100%" valign="top"><table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td><table border="0" width="100%" cellspacing="0" cellpadding="0">
          <tr>
            <td class="pageHeading"><?php echo 'View Counter Database Installer'; ?></td>
          </tr>
        </table></td>
      </tr>
      <tr>
        <td><?php echo tep_draw_separator('pixel_trans.gif', '100%', '10'); ?></td>
      </tr>
      <tr>
        <td class="main">
<?php
  if ($db_error == false) {
    echo 'Database successfully updated for View Counter!!!';
  } else {
    echo 'Update failed!!! View Counter must be installed in order to use this update file.</td></tr>';
  }
?>
        </td>
       </tr>
       <tr>
        <td><?php echo tep_draw_separator('pixel_trans.gif', '100%', '10'); ?></td>
       </tr>
       <tr>
         <td><?php echo '<a href="' . tep_href_link(FILENAME_DEFAULT) . '">' . tep_image_button('button_continue.gif', IMAGE_BUTTON_CONTINUE) . '</a>'; ?></td>
       </tr>
    </table></td>
<!-- body_text_eof //-->

  </tr>
</table>
<!-- body_eof //-->

<?php
function GetCurrentSetting($fields, $option, $sort) {
    $db_query = tep_db_query("select * from configuration where configuration_key = '" . tep_db_input($option) . "'");
    $db = tep_db_fetch_array($db_query);
    $db_str = '';
    
    $insertStr = 'INSERT INTO configuration (';
    unset($db['configuration_id']);
    
    foreach ($db as $key => &$value) {
        $value = tep_db_input($value);
        $db_str .= "'" . $value . "',";
        $insertStr .= $key . ',';
    }
    $insertStr = substr($insertStr, 0, -1) . ' )';
    $db_str = substr($db_str, 0, -1);
    
    return array( $insertStr . "  VALUES ( " . $db_str . " )" );
}
?>

</body>
</html>
